# TP4 MNI cm3 2015-16
#
# Probleme : Solution d'une equation differentielle ordinaire
# Methode : Point au milieu

import numpy as np
import matplotlib.pyplot as plt


def g(a,b,c):
  return c

# Methode du point au milieu
def MP(h,Np,x0,y0,v0,f):
  xt=0.
  yt=0.
  vt=0.
  x=np.zeros(Np)
  y=np.zeros(Np)
  v=np.zeros(Np)
  x[0]=x0
  y[0]=y0
  v[0]=v0
  xp=x0 
  yp=y0
  vp=v0
  for i in range(1,Np):
# x(i), y(i): point courant, xp, yp: point precedent
# xt, yt, vt: point intermediaire
    xt=xp+0.5*h
    yt=yp+0.5*h*g(xp,yp,vp)
    vt=vp+0.5*h*f(xp,yp,vp)
    x[i]=xp+h
    y[i]=yp+h*g(xt,yt,vt)
    v[i]=vp+h*f(xt,yt,vt)
    xp=x[i]
    yp=y[i]
    vp=v[i]

# Valeur en x=10
  xs=10.
  k=int(xs/h)
  print("")
  print("Valeur de la fonction en xs=10")
  print("Pas integration h = %f" %h)
  print("Midpoint: x = %f; y = %f; v = %f" %(x[k],y[k],v[k]))
  print("")

# Graphique 1: y,v en fonction de x
  plt.plot(x,y,'-or',label='y=y(x)')
  plt.plot(x,v,'-*b',label='v=v(x)')
  plt.xlabel("t")
  plt.legend(loc='upper right')
  plt.show()
# Graphique 2: v en fonction de y
  plt.plot(y,v,'-or')
  plt.xlabel("y")
  plt.ylabel("v")
  plt.show()

  return
